(function($){
	"use strict";

	 var Brw_WCFM_Admin = {
        init: function () {

        	// Display help
        	this.brw_wcfm_tip();

        	// Show/Hide custom taxonomy by category
        	this.brw_wcfm_cus_tax_show_hide();

        	// show/hide field with rental type: rental
        	this.brw_wcfm_meta_boxes();

        	// change order list
        	this.brw_wcfm_order_list();
        },
        brw_wcfm_tip: function() {
        	/* Customize Tip when hover help */
			$('#general_product_data #ovabrw-rental .woocommerce-help-tip').mouseover(function(e){
				var tip = $(this).data('tip');
				$(this).append('<span class="content">'+tip+'</span>');
			});
			$('#general_product_data #ovabrw-rental .woocommerce-help-tip').mouseout(function(e){
				$(this).html('');
			});
        },
        brw_wcfm_cus_tax_show_hide: function() {			
		    /* Hide all custom taxonomy in add new product */
		    ovabrw_wcfm_hide_cus_tax( 'loaded' );

		    /* Change category */
		    if ( $( '#product_cats_checklist input' ).length ) {
		        $( '#product_cats_checklist input' ).on( 'change', function( e ) {
		            var that = $(this);

		            that.attr("disabled", 'disabled');

		            /* Hide all custom taxonomy in add new product */
		            ovabrw_wcfm_hide_cus_tax('changed');

		            var checked_tax = ovabrw_wcfm_getSelectedCheckboxValues('product_cats[]');

		            $.ajax({
		                url: ajax_object.ajax_url,
		                type: 'POST',
		                data: ({
		                    action: 'ovabrw_wcfm_get_custom_tax_in_cat',
		                    checked_tax: checked_tax,
		                }),
		                success: function(response) {
		                    that.removeAttr("disabled");

		                    if ( response ) {
		                        var list_tax_values = response.split(",");

		                        if ( list_tax_values.length ) {
			                        for ( var i = 0; i < list_tax_values.length; i++) {
			                            if ( $( ".wcfm_product_taxonomy_"+list_tax_values[i] ).length > 0 ) {
			                                $( ".wcfm_product_taxonomy_"+list_tax_values[i] ).show();
			                            }
			                        }
		                    	}
		                    }		                    
		                },
		            });
		        });
		    }
        },
        brw_wcfm_meta_boxes: function() {
	    	// Loading
	    	$(document).find('#wcfm_products_manage #wcfm_products_manage_form select[name="product_type"]').each( function() {
	    		var type = $(this).val();
	    		var form = $(this).closest('#wcfm_products_manage_form');

	    		ovabrwWcfmMetaBoxes( form, type );

	    		$(this).on( 'change', function() {
	    			var type = $(this).val();
	    			var form = $(this).closest('#wcfm_products_manage_form');

	    			ovabrwWcfmMetaBoxes( form, type );
	    		});
	    	});

	    	// show/hide fields
	    	function ovabrwWcfmMetaBoxes( form = null, type = '' ) {
	    		if ( form.length > 0 && type ) {
	    			if ( 'ovabrw_car_rental' === type ) {
	    				form.find('#general_product_data').removeClass('ovabrw-wcfm-hide');

	    				// is_catalog
    					form.find('input[name="is_catalog"]').addClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_catalog"]').next().addClass('ovabrw-wcfm-hide');

    					// is_catalog
    					form.find('input[name="is_virtual"]').addClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_virtual"]').next().addClass('ovabrw-wcfm-hide');

    					// is_downloadable
    					form.find('input[name="is_downloadable"]').addClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_downloadable"]').next().addClass('ovabrw-wcfm-hide');

	    				// regular_price
	    				form.find('.regular_price').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="regular_price"]').addClass('ovabrw-wcfm-hide');

	    				// sale_price
	    				form.find('.sale_price').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sale_price"]').addClass('ovabrw-wcfm-hide');

	    				// sales_schedule
	    				form.find('.sales_schedule').addClass('ovabrw-wcfm-hide');
	    				form.find('.sale_date_from').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sale_date_from"]').addClass('ovabrw-wcfm-hide');
	    				form.find('.sale_date_upto').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sale_date_upto"]').addClass('ovabrw-wcfm-hide');

	    				// manage_stock
	    				form.find('.manage_stock').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="manage_stock"]').addClass('ovabrw-wcfm-hide');

	    				// stock_qty
	    				form.find('.stock_qty').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="stock_qty"]').addClass('ovabrw-wcfm-hide');

	    				// stock_status
	    				form.find('.stock_status').addClass('ovabrw-wcfm-hide');
	    				form.find('select[name="stock_status"]').addClass('ovabrw-wcfm-hide');

	    				// sold_individually
	    				form.find('.sold_individually').addClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sold_individually"]').addClass('ovabrw-wcfm-hide');
	    			} else {
	    				form.find('#general_product_data').addClass('ovabrw-wcfm-hide');

    					// is_catalog
    					form.find('input[name="is_catalog"]').removeClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_catalog"]').next().removeClass('ovabrw-wcfm-hide');

    					// is_virtual
    					form.find('input[name="is_virtual"]').removeClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_virtual"]').next().removeClass('ovabrw-wcfm-hide');

    					// is_downloadable
    					form.find('input[name="is_downloadable"]').removeClass('ovabrw-wcfm-hide');
    					form.find('input[name="is_downloadable"]').next().removeClass('ovabrw-wcfm-hide');

    					// regular price
    					form.find('.regular_price').removeClass('ovabrw-wcfm-hide');
    					form.find('input[name="regular_price"]').removeClass('ovabrw-wcfm-hide');

    					// sale_price
    					form.find('.sale_price').removeClass('ovabrw-wcfm-hide');
    					form.find('input[name="sale_price"]').removeClass('ovabrw-wcfm-hide');

    					// sales_schedule
	    				form.find('.sales_schedule').removeClass('ovabrw-wcfm-hide');
	    				form.find('.sale_date_from').removeClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sale_date_from"]').removeClass('ovabrw-wcfm-hide');
	    				form.find('.sale_date_upto').removeClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sale_date_upto"]').removeClass('ovabrw-wcfm-hide');

    					// manage_stock
	    				form.find('.manage_stock').removeClass('ovabrw-wcfm-hide');
	    				form.find('input[name="manage_stock"]').removeClass('ovabrw-wcfm-hide');

	    				// stock_qty
	    				form.find('.stock_qty').removeClass('ovabrw-wcfm-hide');
	    				form.find('input[name="stock_qty"]').removeClass('ovabrw-wcfm-hide');

	    				// stock_status
	    				form.find('.stock_status').removeClass('ovabrw-wcfm-hide');
	    				form.find('select[name="stock_status"]').removeClass('ovabrw-wcfm-hide');

	    				// sold_individually
	    				form.find('.sold_individually').removeClass('ovabrw-wcfm-hide');
	    				form.find('input[name="sold_individually"]').removeClass('ovabrw-wcfm-hide');
	    			}
	    		}
	    	}
        },
        brw_wcfm_order_list: function() {
        	// datetime picker
        	$('.ovabrw-wfcm-datetimepicker').each( function() {
	            var allowTimes = '';
	            if ( typeof brw_time_to_book_general_calendar !== 'undefined' ) {
	                allowTimes =  brw_time_to_book_general_calendar.replace(/ /g,'').split( ',' );
	            }

	            var data_step = 30;
	            if ( typeof brw_data_step !== 'undefined' ) {
	                data_step = brw_data_step;
	            }

	            var time_format = '';
	            if ( typeof brw_format_time !== 'undefined' ) {
	                time_format = brw_format_time;
	            }
	            
	            var date_format = '';
	            if ( typeof brw_date_format !== 'undefined' ) {
	                date_format = brw_date_format;
	            }

	            switch ( date_format ) {
	                case 'd-m-Y':
	                    date_format = 'DD-MM-Y';
	                    break;
	                case 'm/d/Y':
	                    date_format = 'MM/DD/Y';
	                    break;
	                case 'Y/m/d':
	                    date_format = 'Y/MM/DD';
	                    break;
	                case 'Y-m-d':
	                    date_format = 'Y-MM-DD';
	                    break;
	                default:
	                    date_format = 'DD-MM-Y';
	            }

	            var firstday = $(this).data('firstday');

	            var datePickerOptions = {
                    scrollInput: false,
                    scrollMonth: false,
                    scrollTime: false,
                    dayOfWeekStart: firstday,
                    format: date_format+' '+time_format,
                    formatDate: date_format,
                    formatTime:time_format,
                    step: data_step,
                    timepicker:true,
                    autoclose: true,
                }

                $(this).datetimepicker(datePickerOptions);
            });

        	// filter
        	$(document).on( 'click', '#wcfm_manage_order_expander #filter-form .ovabrw-wcfm-btn', function(e) {
        		e.preventDefault();

        		var manageOrder = $(this).closest('#wcfm_manage_order_expander');
        		var currentForm = manageOrder.find('form#filter-form');
	    		var processing 	= manageOrder.find('.ovabrw-wcfm-products_processing');
				var body 		= manageOrder.find('table tbody');
				var pagination 	= manageOrder.find('.ovabrw-wcfm-pagination');

        		// Get form data
        		var orderID 		= currentForm.find('input[name="order_id"]').val();
        		var customerName 	= currentForm.find('input[name="customer_name"]').val();
        		var fromDate 		= currentForm.find('input[name="from_date"]').val();
        		var toDate 			= currentForm.find('input[name="to_date"]').val();
        		var pickupLocation 	= currentForm.find('select[name="pickup_location"]').val();
        		var dropoffLocation = currentForm.find('select[name="dropoff_location"]').val();
        		var productID 		= currentForm.find('select[name="product_id"]').val();
        		var orderStatus 	= currentForm.find('select[name="order_status"]').val();
        		var order 			= manageOrder.find('.ovabrw-wcfm-sort-orderid.active').data('order');

    			processing.show();
    			body.hide();
    			pagination.hide();

        		$.ajax({
	                url: ajax_object.ajax_url,
	                type: 'POST',
	                data: ({
	                    action: 'ovabrw_wcfm_filter_order',
	                    order_id: orderID,
	                    customer_name: customerName,
	                    from_date: fromDate,
	                    to_date: toDate,
	                    pickup_location: pickupLocation,
	                    dropoff_location: dropoffLocation,
	                    product_id: productID,
	                    order_status: orderStatus,
	                    order
	                }),
	                success: function(response) {
	                    if ( response ) {
	                    	response = $.parseJSON( response );

	                    	body.html('').append(response.body).css('display', 'table-row-group');
	                    	pagination.html('').append(response.pagination).show();
	                    	manageOrder.find('input[name="ovabrw-wcfm-order-query"]').val(response.query);
	                    }

	                    // processing
	                    processing.hide();
	                },
	            });
        	});

        	// order
        	$(document).on( 'click', '#wcfm_manage_order_expander .ovabrw-wcfm-sort-orderid', function(e) {
        		e.preventDefault();

        		var manageOrder = $(this).closest('#wcfm_manage_order_expander');
        		var currentForm = manageOrder.find('form#filter-form');
	    		var processing 	= manageOrder.find('.ovabrw-wcfm-products_processing');
				var body 		= manageOrder.find('table tbody');
				var pagination 	= manageOrder.find('.ovabrw-wcfm-pagination');

        		// Get form data
        		var orderID 		= currentForm.find('input[name="order_id"]').val();
        		var customerName 	= currentForm.find('input[name="customer_name"]').val();
        		var fromDate 		= currentForm.find('input[name="from_date"]').val();
        		var toDate 			= currentForm.find('input[name="to_date"]').val();
        		var pickupLocation 	= currentForm.find('select[name="pickup_location"]').val();
        		var dropoffLocation = currentForm.find('select[name="dropoff_location"]').val();
        		var productID 		= currentForm.find('select[name="product_id"]').val();
        		var orderStatus 	= currentForm.find('select[name="order_status"]').val();
        		var order 			= $(this).data('order');

        		$(this).removeClass('active');

        		if ( order === 'ASC' ) {
        			$(this).closest('th').find('span[data-order="DESC"]').addClass('active');
        			order = 'DESC';
        		} else if ( order === 'DESC' ) {
        			order = 'ASC';
        			$(this).closest('th').find('span[data-order="ASC"]').addClass('active');
        		}

    			processing.show();
    			body.hide();
    			pagination.hide();

        		$.ajax({
	                url: ajax_object.ajax_url,
	                type: 'POST',
	                data: ({
	                    action: 'ovabrw_wcfm_filter_order',
	                    order_id: orderID,
	                    customer_name: customerName,
	                    from_date: fromDate,
	                    to_date: toDate,
	                    pickup_location: pickupLocation,
	                    dropoff_location: dropoffLocation,
	                    product_id: productID,
	                    order_status: orderStatus,
	                    order: order
	                }),
	                success: function(response) {
	                    if ( response ) {
	                    	response = $.parseJSON( response );

	                    	body.html('').append(response.body).css('display', 'table-row-group');
	                    	pagination.html('').append(response.pagination).show();
	                    	manageOrder.find('input[name="ovabrw-wcfm-order-query"]').val(response.query);
	                    }

	                    // processing
	                    processing.hide();
	                },
	            });
        	});

        	// pagination
        	$(document).on( 'click', '#wcfm_manage_order_expander .ovabrw-wcfm-pagination ul li .page-numbers', function(e) {
        		e.preventDefault();
        		var that = $(this);

        		if ( ! that.hasClass('current') && ! that.hasClass('dots') ) {
        			var processing 		= that.closest('.ovabrw-wcfm-orders').find('.ovabrw-wcfm-products_processing');
        			var body 			= that.closest('.ovabrw-wcfm-orders').find('table tbody');
        			var pagination 		= that.closest('.ovabrw-wcfm-orders').find('.ovabrw-wcfm-pagination');
        			var current_page 	= that.closest('.ovabrw-wcfm-pagination').find('.page-numbers.current').text();
        			var paged 			= that.text();

        			if ( that.hasClass('prev') ) {
        				paged = parseInt( current_page ) - 1;
        			}
        			if ( that.hasClass('next') ) {
        				paged = parseInt( current_page ) + 1;
        			}

        			var orderQuery 	= that.closest('.ovabrw-wcfm-orders').find('input[name="ovabrw-wcfm-order-query"]').val();
        			if ( orderQuery ) orderQuery = $.parseJSON( orderQuery );

        			processing.show();
        			body.hide();
        			pagination.hide();

        			$.ajax({
		                url: ajax_object.ajax_url,
		                type: 'POST',
		                data: ({
		                    action: 'ovabrw_wcfm_get_order_list',
		                    order_query: orderQuery,
		                    paged: paged
		                }),
		                success: function(response) {
		                    if ( response ) {
		                    	response = $.parseJSON( response );

		                    	body.html('').append(response.body).css('display', 'table-row-group');
		                    	pagination.html('').append(response.pagination).show();
		                    }

		                    // processing
		                    processing.hide();
		                },
		            });
        		}
        	});

        	// update order status
        	var previousOrderStatus;

        	$(document).on('focus', '.update_order_status', function() {
        		previousOrderStatus = $(this).val();
        	});

            $(document).on('change', '.update_order_status', function(e) {
            	e.preventDefault();
            	var that = $(this);
                var orderStatusText = that.children("option:selected").html();
                var orderStatusNew 	= that.children("option:selected").val().replace( 'wc-', '' );
                var promptAsk 		= confirm("Do you want to "+$.trim(orderStatusText)+" Booking ?");

                if ( promptAsk == true && orderStatusNew != '') {
                    var orderID = that.data('order_id');
                    
                    var data = {
                        'action': 'ovabrw_wcfm_update_order_status',
                        'order_id': orderID,
                        'new_order_status': orderStatusNew
                    }

                    $.post( ajaxurl, data, function( response ) {
                        if ( response === 'error_permission' ) {
                            alert( that.data('error-per-msg') );
                        } else if( response === 'false' ){
                            alert( that.data('error-update-msg') );
                        }
                    });
                } else {
                	that.val(previousOrderStatus);
                }
            });
        }
    };

	$(document).ready(function(){
		Brw_WCFM_Admin.init();
	});/* Doc ready */

	// Hide custom taxonomies in WCFM
	function ovabrw_wcfm_hide_cus_tax( action ){
		if ( action == 'loaded' ) {
			if( typeof cus_tax_hide_p_loaded != 'undefined' ){

                var array_tax_slug_new = cus_tax_hide_p_loaded.split(",");

                for ( var i = 0; i < array_tax_slug_new.length; i++ ) {
                    if ( $( '.wcfm_product_taxonomy_'+array_tax_slug_new[i] ).length ) {
                        $( '.wcfm_product_taxonomy_'+array_tax_slug_new[i] ).hide();    
                    }
                }
            }
		} else if ( action == 'changed' ) {
			if ( typeof all_cus_tax != 'undefined' ) {
	            var array_tax_slug_new = all_cus_tax.split(",");

	            for ( var i = 0; i < array_tax_slug_new.length; i++ ) {
	                if ( $( '.wcfm_product_taxonomy_'+array_tax_slug_new[i] ).length ) {
	                    $( '.wcfm_product_taxonomy_'+array_tax_slug_new[i] ).hide();    
	                }
	            }
	        }
		}
    }
    
    // Get categories checked
    function ovabrw_wcfm_getSelectedCheckboxValues(name) {
        const checkboxes 	= document.querySelectorAll(`input[name="${name}"]:checked`);
        let values 			= [];

        checkboxes.forEach( (checkbox) => {
            values.push( checkbox.value );
        });

        return values;
    }
}) (jQuery); /* /function($) */   