<?php defined( 'ABSPATH' ) || exit;

if ( ! class_exists( 'OVABRW_WCFM_Hooks' ) ) {

	class OVABRW_WCFM_Hooks {
		/**
		 * __construct()
		 */
		public function __construct() {
			add_filter( 'wcfm_product_types', array( $this, 'ovabrw_wcfm_product_types' ) );
		}

		/**
		 * Add product type: Rental
		 * @param  array $product_types
		 * @return array
		 */
		public function ovabrw_wcfm_product_types( $product_types ) {
			if ( is_array( $product_types ) ) {
				$product_types = array_merge(
					array( 'ovabrw_car_rental' => esc_html__( 'Rental', 'ova-brw-wcfm' ) ),
					$product_types
				);
			}
		    
		    return apply_filters( 'ovabrw_wcfm_product_types', $product_types );
		}
	}

	return new OVABRW_WCFM_Hooks();
}