<?php defined( 'ABSPATH' ) || exit;

if ( ! class_exists( 'OVABRW_WCFM_Rental_Types' ) ) {
	// include abstracts rental type
	include OVABRW_PLUGIN_PATH.'admin/abstracts/abstract-ovabrw-admin-rental-types.php';

	class OVABRW_WCFM_Rental_Types extends OVABRW_Abstract_Admin_Rental_Types {
		/**
		 * __construct()
		 */
		public function __construct() {
			// Include
			$this->includes();

			// View meta boxes
			add_action( 'after_wcfm_products_manage_pricing_fields', array( $this, 'ovabrw_wcfm_product_rental_fields' ) );
			// Save meta boxes
			add_action( 'after_wcfm_products_manage_meta_save', array( $this, 'ovabrw_wcfm_save_metaboxs' ), 20, 2 );
		}

		public function includes() {
			include_once OVABRW_PLUGIN_PATH.'admin/class-ovabrw-admin-meta-boxes.php';
			include_once WC()->plugin_path() . '/includes/admin/wc-meta-box-functions.php';
		}

		public function ovabrw_wcfm_product_rental_fields( $product_id ) {
			$this->ID 		= $product_id;
			$this->type 	= $this->get_value( 'price_type', 'day' );
			$this->title 	= OVABRW_Admin_Meta_Boxes::instance()->rental_types[$this->type]->title;
			$this->prefix 	= OVABRW_PREFIX;
			$this->view 	= OVABRW_Admin_Meta_Boxes::instance()->rental_types[$this->type]->view;

			// View
			require_once( OVABRW_WCFM_PLUGIN_PATH . 'views/wcfm-views-product-rental.php' );
		}

		public function ovabrw_wcfm_save_metaboxs( $post_id, $data ) {
			$type = isset( $data['ovabrw_price_type'] ) ? $data['ovabrw_price_type'] : '';

			if ( $type ) {
				if ( isset( $data['product_type'] ) && $data['product_type'] ) {
					$data['product-type'] = $data['product_type'];
				}

				// rental type
				$rental = OVABRW_Admin_Meta_Boxes::instance()->rental_types;

				if ( isset( $rental[$type] ) && is_object( $rental[$type] ) ) {
					$rental[$type]->save( $post_id, $data );
				}
			}
		}

		public function save( $post_id, $data ) {}
	}

	return new OVABRW_WCFM_Rental_Types();
}