<?php defined( 'ABSPATH' ) || exit;
	$product_ids 	= get_product_ids_by_vendor( get_current_user_id() );
	$product_id 	= isset( $_GET['product_id'] ) ? sanitize_text_field( $_GET['product_id'] ) : '';
	$action 		= get_wcfm_page().'calendar/';
?>
<div class="wrap">
    <div class="booking_filter">
        <form id="booking-filter" method="GET" action="<?php echo esc_url( $action ); ?>">
            <select name="product_id" id="ovabrw-wcfm-select-product">
                <option value="">
                    <?php _e( 'Select Product', 'ova-brw-wcfm' ); ?>
                </option>
                <?php if ( ! empty( $product_ids ) && is_array( $product_ids ) ):
                    foreach ( $product_ids as $p_id ): ?>
                        <option value="<?php echo esc_attr( $p_id ); ?>"<?php selected( $p_id, $product_id ); ?>>
                            <?php echo get_the_title( $p_id ); ?>
                        </option>
                <?php endforeach; endif; ?>
            </select>
            <button type="submit" class="button"><?php esc_html_e( 'Display Schedule', 'ova-brw-wcfm' ); ?></button>
            <?php if ( $product_id ): ?>
            	<div class="ovabrw-wcfm-qty">
	                <?php _e( 'Quantity:','ova-brw-wcfm' ); ?>
	                <?php echo get_post_meta( $product_id, 'ovabrw_car_count', true ); ?>
            	</div>
            <?php
                $statuses   = brw_list_order_status();
                $order_date = OVABRW_Get_Data::instance()->get_order_rent_time( $product_id, $statuses );

                if ( $order_date ) {
                    wp_localize_script( 'calendar_booking', 'order_time', json_decode( $order_date ) );
                    wp_enqueue_script( 'calendar_booking' );
                }

                $toolbar_nav[] = ovabrw_get_setting( get_option( 'ova_brw_calendar_show_nav_month', 'yes' ) ) == 'yes' ? 'dayGridMonth' : '';
                $show_time = ovabrw_get_setting( get_option( 'ova_brw_template_show_time_in_calendar', 'yes' ) ) == 'yes' ? '' : 'ova-hide-time-calendar';

                $nav 	= implode(',', array_filter( $toolbar_nav ) );
                $lang 	= ovabrw_get_setting( get_option( 'ova_brw_calendar_language_general', 'en' ) );
                
                // WPML
                $current_lang = apply_filters( 'wpml_current_language', NULL );

                if ( $current_lang ) {
                    $lang = $current_lang;
                }

                // Polylang
                if ( function_exists('pll_current_language') ) {
                    $lang = pll_current_language();
                }

                $default_view = ( ovabrw_get_setting( get_option( 'ova_brw_calendar_default_view', 'dayGridMonth' ) ) != '' ) ? ovabrw_get_setting( get_option( 'ova_brw_calendar_default_view', 'dayGridMonth' ) ) : 'dayGridMonth';
                ?>
                <div class="wrap_calendar">
                    <div id="<?php echo esc_attr( 'calendar'.$product_id ); ?>" 
                        data-id="<?php echo esc_attr( 'calendar'.$product_id ); ?>"
                        class="ovabrw__product_calendar <?php echo esc_attr( $show_time ); ?>"  
                        data-lang="<?php echo esc_attr( $lang ); ?>" 
                        data-nav="<?php echo esc_attr( $nav ); ?>" 
                        data-default_view="<?php echo esc_attr( $default_view ); ?>" 
                        data_event_number="<?php echo apply_filters( 'ovabrw_event_number_cell', 2 ); ?>">
                        <ul class="intruction">
                            <li>
                                <span class="pink"></span>
                                <span class="white"></span>
                                <span><?php esc_html_e( 'Available','ova-brw-wcfm' ); ?></span>     
                            </li>
                            <li>
                                <?php $background_color_calendar = ovabrw_get_setting( get_option( 'ova_brw_bg_calendar', '#c4c4c4' ) ); ?>
                                <span class="yellow" style="background: <?php echo esc_attr( $background_color_calendar ); ?>" ></span>
                                <span><?php esc_html_e( 'Unavailable','ova-brw-wcfm' ); ?></span>       
                            </li>
                        </ul>
                    </div>
                </div>
            <?php endif; ?>
        </form>
    </div>
</div>